diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
index 31f8d35ba..312cf9a30 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
@@ -38,49 +38,41 @@ public class HudComponentHealthBar
         GL11.glDisable(GL11.GL_BLEND);
 
         boolean heartsFlash = (mc.thePlayer.heartsFlashTime / 3) % 2 == 1;
-        if (mc.thePlayer.heartsFlashTime < 10)
-        {
+        if (mc.thePlayer.heartsFlashTime < 10) {
             heartsFlash = false;
         }
         int health = mc.thePlayer.getHealth();
         int prevHealth = mc.thePlayer.prevHealth;
-        random.setSeed(hud.updateCounter * 0x4c627L);
+        this.random.setSeed(hud.updateCounter * 0x4c627L);
         boolean isHardcore = mc.thePlayer.getGamemode() == Gamemode.hardcore;
 
         for (int i = 0; i < 10; i++) {
             int heartOffset = 0;
-            if (heartsFlash)
-            {
+            if (heartsFlash) {
                 heartOffset = 1;
             }
             int xHeart = x + i * 8;
             int yHeart = y;
-            if (health <= 4)
-            {
-                yHeart += random.nextInt(2);
+            if (health <= 4) {
+                yHeart += this.random.nextInt(2);
             }
 
             hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/container_blinking"));
-            if (heartsFlash)
-            {
-                if (i * 2 + 1 < prevHealth)
-                {
+            if (heartsFlash) {
+                if (i * 2 + 1 < prevHealth) {
                     // Half flash heart icon
                     hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full_blinking"));
                 }
-                if (i * 2 + 1 == prevHealth)
-                {
+                if (i * 2 + 1 == prevHealth) {
                     // Full flash heart icon
                     hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half_blinking"));
                 }
             }
-            if (i * 2 + 1 < health)
-            {
+            if (i * 2 + 1 < health) {
                 // Full heart icon
                 hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full"));
             }
-            if (i * 2 + 1 == health)
-            {
+            if (i * 2 + 1 == health) {
                 // Half heart icon
                 hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half"));
             }
@@ -95,9 +87,9 @@ public class HudComponentHealthBar
                     }
                 }
                 if (mc.objectMouseOver instanceof HitResult.Tile hitTile) {
-                    Block<?> b = mc.currentWorld.getBlock(hitTile.tilePos.x, hitTile.tilePos.y, hitTile.tilePos.z);
+                    Block<?> b = mc.currentWorld.getBlock(hitTile.tilePos);
                     if (Block.getLogicClass(b) instanceof BlockLogicEdible edible) {
-                        healing = edible.getHealAmount(mc.currentWorld, hitTile.tilePos.x, hitTile.tilePos.y, hitTile.tilePos.z);
+                        healing = edible.getHealAmount(mc.currentWorld, hitTile.tilePos);
                     }
                 }
                 if (healing > 0) {
@@ -128,13 +120,11 @@ public class HudComponentHealthBar
         for (int i = 0; i < 10; i++) {
             int xHeart = x + i * 8;
             gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
-            if (i * 2 + 1 < health)
-            {
+            if (i * 2 + 1 < health) {
                 // Full heart icon
                 gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/full"));
             }
-            if (i * 2 + 1 == health)
-            {
+            if (i * 2 + 1 == health) {
                 // Half heart icon
                 gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/half"));
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
index 87e372230..368d59643 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
@@ -1,12 +1,11 @@
 package net.minecraft.client.gui.hud.component;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import org.lwjgl.opengl.GL11;
 
 public class HudComponentOxygenBar
@@ -21,7 +20,7 @@ public class HudComponentOxygenBar
 
     @Override
     public boolean isVisible() {
-        return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.isUnderLiquid(Material.water);
+        return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.isUnderLiquid(Materials.WATER);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
index bae86aa98..2546a7b1b 100644
--- a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
+++ b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -6,12 +6,15 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.helpers.EntitySelector;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
 import java.util.ArrayList;
 import java.util.Collection;
@@ -68,19 +71,20 @@ public class ClientCommandSource implements CommandSource {
     }
 
     @Override
-    public @NotNull Vec3 getCoordinates(boolean offsetHeight) {
-        Vec3 position = this.getSender().getPosition(1.0f, false);
-        if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f);
+    public @Nullable Vector3dc getCoordinates(boolean offsetHeight) {
+        Vector3dc position = this.getSender().getPosition(1.0f, false);
+        if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f, new Vector3d());
         return position;
     }
 
     @Override
-    public @NotNull Vec3 getBlockCoordinates() {
+    public @Nullable TilePosc getBlockCoordinates() {
         if (this.mc.objectMouseOver instanceof HitResult.Tile hitTile) {
-            return Vec3.fromPool(hitTile.tilePos.x, hitTile.tilePos.y, hitTile.tilePos.z);
+            return hitTile.tilePos;
         }
-        Vec3 playerCoordinates = this.getCoordinates(true);
-        return Vec3.fromPool(MathHelper.floor(playerCoordinates.x), MathHelper.floor(playerCoordinates.y), MathHelper.floor(playerCoordinates.z));
+        Vector3dc playerCoordinates = this.getCoordinates(true);
+        assert playerCoordinates != null;
+        return new TilePos(playerCoordinates);
     }
 
     @Override
